import useConfigChatStore from "@/feature/messenger/store/chat_store/useConfigChatStore";
import useConversationsStore from "@/feature/messenger/store/chat_store/useConversationsStore";
import useDragAndDropStore from "@/feature/messenger/store/useDragAndDropStore";
import { FaCloudUploadAlt } from "react-icons/fa";

const DragandDrop = () => {
    //state
    const isDraggingParent = useDragAndDropStore(state => state.isDragging);
    const setIsDragging = useDragAndDropStore(state => state.setIsDragging);
    const handleDragEnter = useDragAndDropStore(state => state.handleDragEnter);
    const agentPermissions = useConfigChatStore(state => state.permisions);
    const selectedConversation = useConversationsStore(state => state.selectedConversation);
    const permissionFile = agentPermissions.adjuntar_archivos;

    const handleDrop = useDragAndDropStore(state => state.handleDrop);
    const handleLocalDrop = (e: any) => {
        e.preventDefault();
        setIsDragging(false);
        const files = e.dataTransfer.files;
        handleDrop(files);
    };

    return (
        <div className={`${isDraggingParent ? 'visible' : 'hidden'} absolute inset-0 m-auto w-[98%] h-[95%] z-10 rounded-xl bg-white/55 backdrop-blur-md shadow-2xl`} 
        onDrop={(e) => handleLocalDrop(e)}
        onDragOver={(e) => handleDragEnter(e, selectedConversation, permissionFile)}
        >
            <div className="w-full h-full flex justify-center items-center">
                <div className="w-full h-full flex flex-col justify-center items-center">
                    <FaCloudUploadAlt size={60} />
                    <div className="text-xl font-semibold">
                        Arrastra y suelta tus archivos
                    </div>
                </div>
            </div>
        </div>
    )
}

export default DragandDrop